#!/bin/bash

set -e

echo "==> apt 패키지 목록 업데이트 중..."
sudo apt update

echo "==> 필수 패키지 설치 중..."
sudo apt install -y apt-transport-https ca-certificates curl software-properties-common gnupg lsb-release

echo "==> Docker GPG 키 등록 중..."
curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo gpg --dearmor -o /usr/share/keyrings/docker-archive-keyring.gpg

echo "==> Docker 저장소 추가 중..."
echo \
  "deb [arch=$(dpkg --print-architecture) signed-by=/usr/share/keyrings/docker-archive-keyring.gpg] \
  https://download.docker.com/linux/ubuntu $(lsb_release -cs) stable" \
  | sudo tee /etc/apt/sources.list.d/docker.list > /dev/null

echo "==> 저장소 반영을 위한 패키지 목록 재업데이트 중..."
sudo apt update

echo "==> Docker CE 설치 중..."
sudo apt install -y docker-ce

echo "==> Docker 서비스 상태 확인:"
sudo systemctl status docker --no-pager

echo "==> 현재 사용자(${USER})를 docker 그룹에 추가 중..."
sudo usermod -aG docker ${USER}

echo "==> 모든 작업 완료! 시스템을 재부팅합니다..."
sleep 3
sudo reboot
